function [sig,fs,name]=createsig_oreja(channel_vect,noise)
%CREATESIG - UI for signal creation
%
% USAGE: [sig,fs,name]=createsig_oreja;
% where
%   sig is the signal
%   fs is the sampling frequency
%   name is the name


parentfig=figure('Visible','off');
udp.sig=[]; 
udp.name='none loaded';

set(parentfig,'UserData',udp);


f=findobj('Tag','createsignaloreja_fig'); 

if ~isempty(f)
    figure(f);
  else     
    createsignaloreja_gui;
    f=findobj('Tag','oreja_fig');
    oud=get(f,'UserData');
    SelectedChannels(oud);
    ud.distorted=oud.distorted;
    ud.selected=oud.selected;
    ud=get(gcf,'UserData');
    ud.parent=parentfig;
    axes(ud.spaxes);
    ud.sigline=line([0 0],[0 0],'ButtonDownFcn','createsignal_oreja play');
    axes(ud.dftaxes);
    ud.dftline=line([0 0],[0 0],'ButtonDownFcn','createsignal_oreja play');
    set(gcf,'UserData',ud);
  end
 %[signal,srate,name]=
 createsignal_oreja('reallyclear');
 
  uiwait
   
  udp=get(parentfig,'UserData');
  sig=udp.sig;
  if nargout > 1
    fs=udp.fs;
  end
  if nargout > 2  
    name=udp.name;
  end  
  delete(parentfig);
     
  
  function SelectedChannels(oud)
  ud=get(gcf,'UserData');
  ud.sig=oud.sig(oud.left3:oud.right3);
  noise=rand(size(ud.sig));
  ud.samps=length(ud.sig);
  ud.sampsPer10ms=round(oud.fs/100);
  e=sampleEnv(ud.sig,ud.sampsPer10ms);
  le=length(e);
  ud.highcf=round(oud.fs/2.5);
  ud.cfs=MakeErbCFs(oud.lowcf,ud.highcf,oud.numchans);
  ud.envs=zeros(oud.numchans,ud.samps);
  ud.cars=zeros(oud.numchans,ud.samps);
  ud.noisecars=zeros(oud.numchans,ud.samps);
  ud.distorted=zeros(oud.numchans,ud.samps);
  ud.t=round(1:ud.sampsPer10ms:ud.samps);
  ud.t=ud.t(1:length(e));
  %delete(get(ud.dftaxes,'Children'));
  numchanssel=0;
  for c=1:oud.numchans
    if (oud.selected(c))
        numchanssel=numchanssel+1;
    end
  end
  set(ud.dftaxes,'XLim',[1 le], 'YLim',[0 numchanssel+1],'YTick',1:numchanssel);
  axes(ud.dftaxes);		
  v=[];
  i=0;
  for c=1:oud.numchans
      if (oud.selected(c))
          i=i+1;
          ud.lines(i)=CreateLine(i,le,ud.dftaxes);
          v=strvcat(v,num2str(round(ud.cfs(c))));
      end    
  end
  set(ud.dftaxes,'YTickLabel',v);
   
  ylabel('channel cf');
  drawnow
  i=0;
  for c=1:oud.numchans
      if (oud.selected(c))
          [env,carrier]=gammatoneEnvCarrier(ud.sig,oud.fs,ud.cfs(c));
          [nenv,ncarrier]=gammatoneEnvCarrier(noise,oud.fs,ud.cfs(c));
          ud.envs(c,:) = env;
          ud.cars(c,:) = carrier;
          ud.noisecars(c,:) = ncarrier;
          ud.distorted(c,:) = env.*carrier;
          e=sampleEnv(ud.distorted(c,:),ud.sampsPer10ms);
          i=i+1;
          ChangeLine(ud.lines(i),i,e); 
          drawnow
      end
  end  

  set(gcf,'UserData',ud)

 % oreja 'drawspect'

 %-----------
function e=sampleEnv(env,interval)
pts=round(length(env)/interval)-1;
e=max(abs(reshape(env(1:(interval*pts)),interval,pts)));

%------
function l=CreateLine(p,len,parent)
x=[1:len (len-1):-1:2];
y=p*ones(size(x));
pat=patch(x,y,[0.9 0.9 0.7]);
set(pat,'Erasemode','xor');
l=line(1:len,p*ones(1,len));
set(l,'Color',[0.9 0.9 0.7],'Erasemode','xor','ButtonDownFcn',...
'createsignal_oreja selectSignal');
%set(l,'Color',[0.5 0.2 0.7],'Erasemode','xor');
lud.patch=pat;
lud.chan=p;
set(l,'UserData',lud);

%--------
function [env,carrier]=gammatoneEnvCarrier(x,fshz,cfhz)
% envelope and carrier form of complex gammatone

bwcorrection=1.019;
wcf=2*pi*cfhz;
tpt=(2*pi)/fshz;
bw=erb(cfhz)*bwcorrection;

a=exp(-bw*tpt);
kT=[0:length(x)-1]/fshz;
gain=((bw*tpt)^4)/6;                          % integral of imp resp

q=exp(-j*wcf*kT).*x;                          % shift down to d.c.
p=filter([1 0],[1 -4*a 6*a^2 -4*a^3 a^4],q);	% filter: part 1
u=filter([1 4*a 4*a^2 0],[1 0],p);            % filter: part 2
env=gain*abs(u);
carrier=cos(wcf*kT + angle(u));

function ChangeLine(l,c,env)
lud=get(l,'UserData');
lenv=length(env);
set(lud.patch,'YData',[c+3*env c-3*fliplr(env(2:lenv-1))]);
