function [signal,srate,name]=createsignal_oreja(action)
%CREATESIGNAL_OREJA user-controlled signal manipulation

switch action
    
    
    
    case 'handleradio'
        %Only one distortion can be selected
        ud=get(gcf,'UserData');
        rbs=findobj(gcf,'Tag','sigradio');
        set(rbs,'Value',0);
        set(gcbo,'Value',1);
        ud.lastradio=gcbo;
        selectradio=get(ud.lastradio,'String');
        set(findobj(gcf,'Tag','addButton'),'Enable','on');
        set(gcf,'UserData',ud);
        
        
        switch selectradio
            case 'tone'  
                set([ud.freqlevel ud.freq ud.reperiod ud.from ud.to ud.rampms...
                        ud.dur],'Enable','on');
            case 'time reverse'           
                set([ud.freq ud.freqlevel ud.from ud.reperiod...
                        ud.rampms ud.to ud.rampms ud.dur],'Enable','off');         
            case 'speech'
                set([ ud.rampms ud.freqlevel ud.from ud.reperiod ud.to ud.rampms ud.dur],'Enable','on');
                set([  ud.freq ],'Enable','off');  
            case 'noises'
                set([ud.freqlevel ud.reperiod ud.from ud.to ud.rampms...
                        ud.dur],'Enable','on');
                set([ ud.freq ud.rampms],'Enable','off');  
            case 'gain'
                set([ud.freqlevel],'Enable','on');
                set([ud.freq ud.reperiod ud.from ud.to...
                        ud.rampms ud.dur],'Enable','off');             
            case 'sinewaves replicas'
                set([ud.freqlevel ud.from ud.reperiod...
                        ud.rampms ud.to ud.rampms ud.dur],'Enable','off'); 
                
        end
        
        
        
    case 'plotCursors'
        ud=get(gcf,'UserData');
        set(ud.dftaxesRC, 'XData',[ud.right1 ud.right1]);
        set(ud.dftaxesLC, 'XData',[ud.left1 ud.left1]);
        set(ud.spaxesRC, 'XData',[ud.right2 ud.right2]);
        set(ud.spaxesLC, 'XData',[ud.left2 ud.left2]);
        
        
        drawnow
        
        
         
        
    case 'left'
        
        set(gcf,'WindowButtonMotionFcn','createsignal_oreja moveleft');
        set(gcf,'WindowButtonUpFcn','createsignal_oreja release');  
        
        
    case 'derecha'
        
        set(gcf,'WindowButtonMotionFcn','createsignal_oreja moveright');
        set(gcf,'WindowButtonUpFcn','createsignal_oreja release');  
        
        
    case 'release'
        set(gcf,'WindowButtonMotionFcn','createsignal_oreja motion');
        
    case 'changeto'
        %The cursors move to the position specified in 'to'
        ud=get(gcf,'UserData');
        xlims=get(ud.dftaxes,'XLim');
        timespan=ud.samps/ud.fs;
        to=getuicontrolvalue(ud.to,'num');
        ud.right1=to*(xlims(2)/(1000*timespan));
        ud.right2=round(ud.right1*((ud.spaxesright-1)/(ud.dftaxesright-1)))+1;
        ud.right1=round(ud.right1)+1;
        
        set(gcf,'UserData',ud);
        createsignal_oreja plotCursors;
        
    case 'changefrom'
        %The cursors move to the position specified in 'from'
        ud=get(gcf,'UserData');
        xlims=get(ud.dftaxes,'XLim');
        timespan=ud.samps/ud.fs;
        from=getuicontrolvalue(ud.from,'num');
        ud.left1=from*(xlims(2)/(1000*timespan));
        ud.left2=round(ud.left1*((ud.spaxesright-1)/(ud.dftaxesright-1)))+1;
        ud.left1=round(ud.left1)+1;
        
        set(gcf,'UserData',ud);
        createsignal_oreja plotCursors;
        
    case 'moveright'
        ud=get(gcf,'UserData');
        cp=get(gca,'CurrentPoint');
        
        xlims=get(ud.dftaxes,'XLim');
        xlims2=get(ud.spaxes,'XLim');
        
        if (gca == findobj('Tag','spWin'))
            ud.right2=min(max(cp(1),ud.left2),xlims2(2)-2); 
            ud.right1=round(ud.right2*((ud.dftaxesright-1)/(ud.spaxesright-1)))+1;
            ud.right2=round(ud.right2)+1;
        end
        
        if (gca == findobj('Tag','dftWin'))
                      
            ud.right1=min(max(cp(1),ud.left1),xlims(2)-2); 
            ud.right2=round(ud.right1*((ud.spaxesright-1)/(ud.dftaxesright-1)))+1;
            ud.right1=round(ud.right1)+1;
        end        
        
        xlims=get(ud.dftaxes,'XLim');
        timespan=ud.samps/ud.fs;
        set(ud.timebox,'String',num2str(round((((ud.right1-1)*((1000*timespan)/xlims(2))))),'%.1f'));
        set(ud.to,'String',num2str((((ud.right1-1)*((1000*timespan)/xlims(2)))),'%.1f'));
        
        set(gcf,'UserData',ud);
        createsignal_oreja plotCursors;
        
    case 'moveleft'
        ud=get(gcf,'UserData');
        cp=get(gca,'CurrentPoint');
        if (gca == findobj('Tag','spWin'))
            %%%
            ud.left2=max(min(cp(1),ud.right2),1); 
            ud.left1=round(ud.left2*((ud.dftaxesright-1)/(ud.spaxesright-1)))+1;
            ud.left2=round(ud.left2)+1;
        end
        
        if (gca == findobj('Tag','dftWin'))
            ud.left1=max(min(cp(1),ud.right1),0); 
            ud.left2=round(ud.left1*((ud.spaxesright-1)/(ud.dftaxesright-1)))+1;
            ud.left1=round(ud.left1)+1;
        end        
        
        xlims=get(ud.dftaxes,'XLim');
        timespan=ud.samps/ud.fs;
        set(ud.timebox,'String',num2str(round(((ud.left1-1)*((1000*timespan)/xlims(2)))),'%.1f'));
        set(ud.from,'String',num2str((((ud.left1-1)*((1000*timespan)/xlims(2)))),'%.1f'));
        
        set(gcf,'UserData',ud);
        
        createsignal_oreja plotCursors;
        
        
        
        
    case 'motion'
        ud=get(gcf,'UserData');  
        cp=get(ud.spaxes,'CurrentPoint')';
        %cpp=get(ud.wavAxes,'CurrentPoint')';
        t=cp(1); f=cp(2);
        %t=cpp(1); f=cpp(2);
        xlims=get(ud.spaxes,'XLim');
        ylims=get(ud.spaxes,'YLim');
        timespan=ud.samps/ud.fs;
        if and(t>xlims(1),t<xlims(2))
            set(ud.timebox,'String',num2str(round(((t-1)*((1000*timespan)/xlims(2)))),'%.1f'));
        end
        if and(f>ylims(1),f<ylims(2))
            if and(t>xlims(1),t<xlims(2))
                set(ud.freqbox,'String',num2str(round((f-1)*ud.fs/(2*(ylims(2)-ylims(1)))),'%.1f'));
            end
        end
        
        
    case 'clear'
        %This is the undo funcion
        ud=get(gcf,'UserData');
        if ~isempty(ud.UndoList)   
            if ud.UndoList(size(ud.UndoList,1),1) == 0
                
                originalsig=ud.selected*ud.distorted;
                ud.added=ud.added-1;
                ud.addedsignals=ud.addedsignals(1:ud.added,:);
                SeeSigSpect(originalsig,ud.addedsignals,ud.fs,ud);
                ud.UndoList=ud.UndoList(1:size(ud.UndoList,1)-1,:);
                drawnow 
            else 
                if ud.UndoList(size(ud.UndoList,1),1) == 1
                    rows=size(ud.UndoList,1);
                    cols=size(ud.UndoList,2);
                    ud.inverted=ud.UndoList(rows,2:cols);
                    originalsig=ud.selected*ud.distorted;
                    SeeSigSpect(originalsig,ud.addedsignals,ud.fs,ud);
                    ud.UndoList=ud.UndoList(1:size(ud.UndoList,1)-1,:);
                    drawnow
                else 
                    if ud.UndoList(size(ud.UndoList,1),1) == 2
                        rows=size(ud.UndoList,1);
                        cols=size(ud.UndoList,2);
                        ud.gain=ud.UndoList(rows,2:cols);
                        originalsig=ud.selected*ud.distorted;
                        SeeSigSpect(originalsig,ud.addedsignals,ud.fs,ud);
                        ud.UndoList=ud.UndoList(1:size(ud.UndoList,1)-1,:);
                        drawnow
                    else
                        if ud.UndoList(size(ud.UndoList,1),1) == 3
                            rows=size(ud.UndoList,1);
                            cols=size(ud.UndoList,2);
                            ud.sinewaved=ud.UndoList(rows,2:cols);
                            originalsig=ud.selected*ud.distorted;
                            SeeSigSpect(originalsig,ud.addedsignals,ud.fs,ud);
                            ud.UndoList=ud.UndoList(1:size(ud.UndoList,1)-1,:);
                            drawnow
                        end
                    end
                    
                end
            end
        end
        if isempty(ud.UndoList)
            ud.nosignal=1;
            set(findobj('Tag','clearButton'),'Enable','off');
            set(findobj('Tag','clearallButton'),'Enable','off');
        end
        
        set(gcf,'UserData',ud);
        
        
    case 'playMix'
        ud=get(gcf,'UserData');
        signal=AssembleSignal(ud);
        wavplay(signal,ud.fs,'sync');
 
        
        
    case 'playOriginal'
        ud=get(gcf,'UserData');
        signal=ud.selected*ud.distorted;
        wavplay(signal,ud.fs);
        
    %Raul Por que el 'reallyclear'  afecta a las bolitas de seleccion   
    case 'reallyclear'
        colormap(pink.*summer.*gray);  
        ud=get(gcf,'UserData');
        ud.sig=0;
        ud.added=0;
        ud.addedsignals=[];
        ud.nosignal=1;
        ud.name=[]; 
        ud.UndoList=[];
        
        
        
        f=findobj('Tag','oreja_fig');
        oud=get(f,'UserData');
        ud.signaldir=oud.signaldir;
        ud.fs = oud.fs; 
        ud.highcf=oud.highcf;
        ud.lowcf=oud.lowcf;
        ud.numchans=oud.numchans;
        ud.selected=oud.selected;
        ud.distorted=oud.distorted(:,oud.left3:oud.right3);
        ud.samps=oud.right3-oud.left3;
        ud.cfs=MakeErbCFs(ud.lowcf,ud.highcf,ud.numchans);
        ud.gain=ones(1,sum(ud.selected));
        ud.inverted=zeros(1,sum(ud.selected));
        ud.sinewaved=zeros(1,sum(ud.selected));
        ud.left2=1;
        ud.right2=1;
        set(ud.chanAxes,'XLim',[1 3], 'YLim',[0 ud.selected*ones(length(ud.selected),1)+1]);
        
        
        set(gcf,'Name',strcat('Oreja. Manipulation: - [',oud.name,']'),...
            'WindowButtonMotionFcn','createsignal_oreja motion');
        
        set(gcf,'UserData',ud);
        
        createsignal_oreja 'display';
        drawspect(ud);
        %                SeeSigSpect(ud.selected*ud.distorted,ud.addedsignals,ud.fs,ud)
        ud=get(gcf,'UserData');
        xlims=get(ud.dftaxes,'XLim');
        ud.dftaxesright=xlims(2);
        ud.right1=round(0.9*(ud.dftaxesright-1))+1;
        ud.left1=round(0.1*(ud.dftaxesright-1))+1;
        
        xlims=get(ud.spaxes,'XLim');
        ud.spaxesright=xlims(2);
        ud.right2=round(0.9*(ud.spaxesright-1))+1;
        ud.left2=round(0.1*(ud.spaxesright-1))+1;
        
        
        % LINES
        ud.spaxesLC = line('Parent',ud.spaxes,'ButtonDownFcn','createsignal_oreja left',...
            'EraseMode','xor','XData',[ud.left2 ud.left2],'YData',get(ud.spaxes,'Ylim'),'Color','black');
        ud.spaxesRC = line('Parent',ud.spaxes,'ButtonDownFcn','createsignal_oreja derecha',...
            'EraseMode','xor','XData',[ud.right2 ud.right2],'YData',get(ud.spaxes,'Ylim'),'Color','black');
        
        ud.dftaxesLC = line('Parent',ud.dftaxes,'Color','black',...
            'EraseMode','xor','XData',[ud.left1 ud.left1],'YData',get(ud.dftaxes,'Ylim'),'ButtonDownFcn','createsignal_oreja left');
        ud.dftaxesRC = line('Parent',ud.dftaxes,'Color','black',...
            'EraseMode','xor','XData',[ud.right1 ud.right1],'YData',get(ud.dftaxes,'Ylim'),'ButtonDownFcn','createsignal_oreja derecha');
        v=[];
        tmp=0;
        for c=1:ud.numchans 
            
            
            if oud.selected(c)
                tmp=tmp+1;
                ud.squares(tmp)=CreateSquare(c,tmp,3,ud.chanAxes);
                
                v=strvcat(v,num2str(round(ud.cfs(c))));
            end
        end
        set(ud.dftaxes,'YTickLabel',v);
        
        
        
        set(ud.spaxes,'YTickLabel',v);
        
        xlimit=get(ud.dftaxes,'XLim');
        
        timespan=ud.samps/ud.fs;
        
        for i=-5:5
            if and(timespan/(10^i)>=1, timespan/(10^i)<10)
                unit=10^i;
            end
        end
        
        if (unit/timespan) <=5
            unit=unit/2;
        end
        
        set(ud.dftaxes,'XTick',(1:xlimit(2)*(unit/timespan):xlimit(2)));
        xlimit=get(ud.spaxes,'XLim');
        
        set(ud.spaxes,'XTick',(1:xlimit(2)*(unit/timespan):xlimit(2)));
        v=[];
        
        if (timespan < 5)
            for c=0:timespan/unit
                text=num2str(round(unit*c*1000));
                v=strvcat(v,text);
            end
        else
            for c=0:timespan/unit
                text=num2str(unit*c);
                pos=findstr('.',text);
                if isempty(pos)
                    text=strcat(text,'.0');
                end
                
                if ~isempty(pos)
                    text=text(1:pos+1);
                end
                v=strvcat(v,text);
            end
        end
        
        
        set(ud.dftaxes,'XTickLabel',v);
        set(ud.spaxes,'XTickLabel',v);
        set(findobj(gcf,'Tag','toButton'),'String',timespan*1000);
        
        
        set(findobj(gcf,'Tag','playButton'),'Enable','on');
        % set(ud.dur,'Enable','on');
        set(findobj(gcf,'Tag','saveButton'),'Enable','on');
        set(findobj(gcf,'Tag','clearallButton'),'Enable','off');
        set(findobj(gcf,'Tag','clearButton'),'Enable','off');
        ud.manipulated=zeros(1,length(ud.selected));
        set(gcf,'UserData',ud);
        set(ud.from,'String',num2str(0.1*1000*ud.samps/ud.fs,'%.1f'));
        set(ud.to,'String',num2str(0.9*1000*ud.samps/ud.fs,'%.1f'));
        rbs=findobj(gcf,'Tag','sigradio');
        set(rbs,'Enable','on');
        
        
    case 'add'
        % find what we're meant to create
        ud=get(gcf,'UserData');
        if ud.nosignal
            ud.nosignal=0;
            % set(ud.dur,'Enable','off');
            
            set(findobj('Tag','clearButton'),'Enable','on');
            set(findobj('Tag','clearallButton'),'Enable','on');
            
        end
        
        
        durms=getuicontrolvalue(ud.dur,'num');
        %fs=getuicontrolvalue(ud.fs,'num');
        fs=ud.fs;
        dursamps=round(fs*durms/1000);
        rampsamps=round(fs*getuicontrolvalue(ud.rampms,'num')/1000);
        from=getuicontrolvalue(ud.from,'num');
        to=getuicontrolvalue(ud.to,'num');
        if (isfield(ud, 'lastradio'))
            sigtype=get(ud.lastradio,'String');
        else
            rbs=findobj(gcf,'Tag','sigradio');
            get(rbs,'Value')
        end
        level=dB2amp(getuicontrolvalue(ud.freqlevel,'num'));
        
        originalsig=ud.selected*ud.distorted;

        switch sigtype
            
            case 'tone'
                if max(originalsig) ~= 0
                    level=level*(max(originalsig)/10);
                end
                
                freq=getuicontrolvalue(ud.freq,'num');
                
                %frompadding are the zeros that precede the signal.
                frompadding=max(round(from*ud.fs/1000),1);
                %topadding are the zeros that postpone the signal.
                topadding=max(size(originalsig,2)-round(to*ud.fs/1000),1);
                %inpadding are the zeros between frompadding and toppading.
                inpadding=max(size(originalsig,2)-frompadding-topadding,1);
                reperiod=getuicontrolvalue(ud.reperiod,'num');
                duration=getuicontrolvalue(ud.dur,'num');
                insert=[];
                if  reperiod > 0
                    for i=1:ceil((to-from)/reperiod)
                        tempsig=localtone(freq,round(duration*ud.fs/1000),level,fs);
                        if rampsamps > 0
                            if rampsamps*2 > length(tempsig)
                                rampsamps=round(length(tempsig)/2);
                                set(ud.rampms,'String',num2str(round(1000*rampsamps/fs)));
                            end
                            t=0:rampsamps-1; c=pi/(rampsamps-1);
                            ham=0.5-0.5*cos(c*t);
                            %hwin=round(rampsamps/2);
                            hwin=rampsamps;
                            ramp=ones(1,length(tempsig));
                            ramp(1:hwin)=ham(1:hwin);
                            dursamps=length(tempsig);
                            ramp(dursamps-hwin+1:dursamps)=fliplr(ham(1:hwin));
                            tempsig=tempsig.*ramp;
                        end  
                        insert=[insert tempsig zeros(1,round(reperiod*ud.fs/1000-duration*ud.fs/1000)) ];
                    end
                    if inpadding < size(insert,2)
                        insert=insert(:,1:inpadding);
                                     if rampsamps > 0
                             if rampsamps*2 > length(insert)
                                rampsamps=round(length(insert)/2);
                                set(ud.rampms,'String',num2str(round(1000*rampsamps/fs)));
                            end
                            t=0:rampsamps-1; c=pi/(rampsamps-1);
                            ham=0.5-0.5*cos(c*t);
                            %hwin=round(rampsamps/2);
                            hwin=rampsamps;
                            ramp=ones(1,length(insert));
                            dursamps=length(insert);
                            ramp(dursamps-hwin+1:dursamps)=fliplr(ham(1:hwin));
                            
                            insert=insert.*ramp;
                        end  
         

                    end
                else
                    insert=localtone(freq,size(originalsig,2)-frompadding-topadding,level,fs);
                                   if rampsamps > 0
                             if rampsamps*2 > length(insert)
                                rampsamps=round(length(insert)/2);
                                set(ud.rampms,'String',num2str(round(1000*rampsamps/fs)));
                            end
                            t=0:rampsamps-1; c=pi/(rampsamps-1);
                            ham=0.5-0.5*cos(c*t);
                            %hwin=round(rampsamps/2);
                            hwin=rampsamps;
                            ramp=ones(1,length(insert));
                            ramp(1:hwin)=ham(1:hwin);
                            dursamps=length(insert);
                            ramp(dursamps-hwin+1:dursamps)=fliplr(ham(1:hwin));
                            
                            insert=insert.*ramp;
                        end  
                end
                sig=[zeros(1,frompadding) insert zeros(1,size(originalsig,2)-size(insert,2)-frompadding)];
                ud.addedsignals=[ud.addedsignals; sig];
                ud.added=ud.added+1;
                
                SeeSigSpect(originalsig,ud.addedsignals,fs,ud);
                
                ud.UndoList=[ud.UndoList; [0 zeros(1,ud.numchans)]]; 
                set(gcf,'UserData',ud);  
                % createsignal_oreja plotCursors;
                drawnow;
                
                
            case 'sinewaves replicas'
                
                
                if sum(ud.manipulated) > 0
                    
                    ud.UndoList=[ud.UndoList; [3 ud.sinewaved]]; 
                    for i=1:length(ud.sinewaved)
                        if ud.manipulated(i)==1
                            
                            ud.sinewaved(i)=1;
                            
                        end
                    end
                    
                    SeeSigSpect(originalsig,ud.addedsignals,fs,ud);        
                    
                end
                set(gcf,'UserData',ud);
                
            case 'noises'
                noisetype=getuicontrolvalue(ud.noisetype,'string');         
                if max(originalsig) ~= 0
                    level=level*(max(originalsig)/10);
                end
                
                switch noisetype 
                    
                    case 'white';
                        
                        sig=level.*(rand(1,size(originalsig,2)));
                        from=getuicontrolvalue(ud.from,'num');
                        to=getuicontrolvalue(ud.to,'num');
                        %frompadding are the zeros that precede the signal.
                        frompadding=max(round(from*ud.fs/1000),1);
                        %topadding are the zeros that postpone the signal.
                        topadding=max(size(originalsig,2)-round(to*ud.fs/1000),1);
                        %inpadding are the zeros between frompadding and toppading.
                        inpadding=max(size(originalsig,2)-frompadding-topadding,1);
                        reperiod=getuicontrolvalue(ud.reperiod,'num');
                        duration=getuicontrolvalue(ud.dur,'num');
                        insert=[];
                        if  reperiod > 0
                            for i=1:ceil((to-from)/reperiod)
                                
                                insert=[insert level.*rand(1,round(duration*ud.fs/1000)) zeros(1,round((reperiod-duration)*ud.fs/1000)) ];
                            end
                            if inpadding < size(insert,2)
                                insert=insert(:,1:inpadding);
                            end
                        else
                            insert=level.*rand(1,size(originalsig,2)-frompadding-topadding);
                        end
                        sig=[zeros(1,frompadding) insert zeros(1,size(originalsig,2)-size(insert,2)-frompadding)];
                        
                        %sig=[zeros(1,frompadding) level.*(rand(1,size(originalsig,2)-frompadding-topadding)) zeros(1,topadding)];
                        
                        ud.addedsignals=[ud.addedsignals; sig];
                        ud.added=ud.added+1;
                        
                        SeeSigSpect(originalsig,ud.addedsignals,fs,ud);
                        ud.UndoList=[ud.UndoList; [0 zeros(1,ud.numchans)]]; 
                        set(gcf,'UserData',ud);  
                        drawnow
                        
                    case 'brown';
                        
                        
                        %frompadding are the zeros that precede the signal.
                        frompadding=max(round(from*ud.fs/1000),1);
                        %topadding are the zeros that postpone the signal.
                        topadding=max(size(originalsig,2)-round(to*ud.fs/1000),1);
                        %inpadding are the zeros between frompadding and toppading.
                        inpadding=max(size(originalsig,2)-frompadding-topadding,1);
                        reperiod=getuicontrolvalue(ud.reperiod,'num');
                        duration=getuicontrolvalue(ud.dur,'num');
                        insert=[];
                        
                        if  reperiod > 0
                            for i=1:ceil((to-from)/reperiod)
                                
                                insert=[insert level.*brown_noise(fs,round(duration*ud.fs/1000)) zeros(1,round((reperiod-duration)*ud.fs/1000)) ];
                            end
                            if inpadding < size(insert,2)
                                insert=insert(:,1:inpadding);
                            end
                        else
                            insert=level.*brown_noise(fs,size(originalsig,2)-frompadding-topadding);
                        end
                        sig=[zeros(1,frompadding) insert zeros(1,size(originalsig,2)-size(insert,2)-frompadding)];
                        
                        % sig=[zeros(1,frompadding) level.*brown_noise(fs,size(originalsig,2)-frompadding-topadding) zeros(1,topadding)];
                        
                        
                        ud.addedsignals=[ud.addedsignals; sig];
                        ud.added=ud.added+1;
                        
                        SeeSigSpect(originalsig,ud.addedsignals,fs,ud);
                        ud.UndoList=[ud.UndoList; [0 zeros(1,ud.numchans)]]; 
                        set(gcf,'UserData',ud);  
                        drawnow;
                        
                    case 'pink';
                        
                        %frompadding are the zeros that precede the signal.
                        frompadding=max(round(from*ud.fs/1000),1);
                        %topadding are the zeros that postpone the signal.
                        topadding=max(size(originalsig,2)-round(to*ud.fs/1000),1);
                        %inpadding are the zeros between frompadding and toppading.
                        inpadding=max(size(originalsig,2)-frompadding-topadding,1);
                        reperiod=getuicontrolvalue(ud.reperiod,'num');
                        duration=getuicontrolvalue(ud.dur,'num');
                        insert=[];
                        if  reperiod > 0
                            for i=1:ceil((to-from)/reperiod)
                                
                                insert=[insert level.*pink_noise(fs,round(duration*ud.fs/1000)) zeros(1,round((reperiod-duration)*ud.fs/1000)) ];
                            end
                            if inpadding < size(insert,2)
                                insert=insert(:,1:inpadding);
                            end
                        else
                            insert=level.*pink_noise(fs,size(originalsig,2)-frompadding-topadding);
                        end
                        sig=[zeros(1,frompadding) insert zeros(1,size(originalsig,2)-size(insert,2)-frompadding)];
                        
                        
                        %    sig=[zeros(1,frompadding) level.*pink_noise(fs,size(originalsig,2)-frompadding-topadding) zeros(1,topadding)];
                        
                        
                        ud.addedsignals=[ud.addedsignals; sig];
                        ud.added=ud.added+1;
                        
                        SeeSigSpect(originalsig,ud.addedsignals,fs,ud);
                        ud.UndoList=[ud.UndoList; [0 zeros(1,ud.numchans)]]; 
                        set(gcf,'UserData',ud);  
                        drawnow;
                        
                    case 'chirp up'
                        %frompadding are the zeros that precede the signal.
                        frompadding=max(round(from*ud.fs/1000),1);
                        %topadding are the zeros that postpone the signal.
                        topadding=max(size(originalsig,2)-round(to*ud.fs/1000),1);
                        %inpadding are the zeros between frompadding and toppading.
                        inpadding=max(size(originalsig,2)-frompadding-topadding,1);
                        reperiod=getuicontrolvalue(ud.reperiod,'num');
                        duration=getuicontrolvalue(ud.dur,'num');
                        insert=[];
                        if  reperiod > 0
                            for i=1:ceil((to-from)/reperiod)
                                
                                insert=[insert level.*chirp_up(fs,round(duration*ud.fs/1000)) zeros(1,round((reperiod-duration)*ud.fs/1000)) ];
                            end
                            if inpadding < size(insert,2)
                                insert=insert(:,1:inpadding);
                            end
                        else
                            insert=level.*chirp_up(fs,size(originalsig,2)-frompadding-topadding);
                        end
                        sig=[zeros(1,frompadding) insert zeros(1,size(originalsig,2)-size(insert,2)-frompadding)];
                        
                        
                        %sig=[zeros(1,frompadding) level.*chirp_up(fs,size(originalsig,2)-frompadding-topadding) zeros(1,topadding)];
                        
                        % sig=level.*chirp_up(fs,size(originalsig,2));
                        ud.addedsignals=[ud.addedsignals; sig];
                        ud.added=ud.added+1;
                        
                        SeeSigSpect(originalsig,ud.addedsignals,fs,ud);
                        ud.UndoList=[ud.UndoList; [0 zeros(1,ud.numchans)]]; 
                        set(gcf,'UserData',ud);  
                        drawnow
                        
                    case 'chirp down'
                        %frompadding are the zeros that precede the signal.
                        frompadding=max(round(from*ud.fs/1000),1);
                        %topadding are the zeros that postpone the signal.
                        topadding=max(size(originalsig,2)-round(to*ud.fs/1000),1);
                        %inpadding are the zeros between frompadding and toppading.
                        inpadding=max(size(originalsig,2)-frompadding-topadding,1);
                        reperiod=getuicontrolvalue(ud.reperiod,'num');
                        duration=getuicontrolvalue(ud.dur,'num');
                        insert=[];
                        if  reperiod > 0
                            for i=1:ceil((to-from)/reperiod)
                                
                                insert=[insert level.*chirp_down(fs,round(duration*ud.fs/1000)) zeros(1,round((reperiod-duration)*ud.fs/1000)) ];
                            end
                            if inpadding < size(insert,2)
                                insert=insert(:,1:inpadding);
                            end
                        else
                            insert=level.*chirp_down(fs,size(originalsig,2)-frompadding-topadding);
                        end
                        sig=[zeros(1,frompadding) insert zeros(1,size(originalsig,2)-size(insert,2)-frompadding)];
                        
                        
                        %           sig=[zeros(1,frompadding) level.*chirp_down(fs,size(originalsig,2)-frompadding-topadding) zeros(1,topadding)];
                        
                        ud.addedsignals=[ud.addedsignals; sig];
                        ud.added=ud.added+1;
                        
                        SeeSigSpect(originalsig,ud.addedsignals,fs,ud);
                        ud.UndoList=[ud.UndoList; [0 zeros(1,ud.numchans)]]; 
                        set(gcf,'UserData',ud);  
                        drawnow
                end
                
                set(gcf,'UserData',ud); 
                
                
                
            case 'speech'
                
                [name,adsig,fs]=loadsig(ud.signaldir);
                if length(adsig)
                    if size(adsig,1) > 1
                        adsig=adsig';
                    end
                    %frompadding are the zeros that precede the signal.
                    frompadding=max(round(from*ud.fs/1000),1);
                    %topadding are the zeros that postpone the signal.
                    topadding=max(size(originalsig,2)-round(to*ud.fs/1000),1);
                    %inpadding are the zeros between frompadding and toppading.
                    inpadding=max(size(originalsig,2)-frompadding-topadding,1);
                    reperiod=getuicontrolvalue(ud.reperiod,'num');
                    duration=getuicontrolvalue(ud.dur,'num');
                    insert=[];
                    
                    if length(adsig) > size(originalsig,2)-frompadding-topadding
                        adsig=adsig(1:size(originalsig,2)-frompadding-topadding);
                        tempsig=adsig;
                        if rampsamps > 0
                            if rampsamps*2 > length(tempsig)
                                rampsamps=round(length(tempsig)/2);
                                set(ud.rampms,'String',num2str(round(1000*rampsamps/fs)));
                            end
                            t=0:rampsamps-1; c=pi/(rampsamps-1);
                            ham=0.5-0.5*cos(c*t);
                            %hwin=round(rampsamps/2);
                            hwin=rampsamps;
                            ramp=ones(1,length(tempsig));
                            ramp(1:hwin)=ham(1:hwin);
                            dursamps=length(tempsig);
                            ramp(dursamps-hwin+1:dursamps)=fliplr(ham(1:hwin));
                            adsig=tempsig.*ramp;
                        end  
                        
                    else
                        tempsig=adsig;
                        if rampsamps > 0
                            if rampsamps*2 > length(tempsig)
                                rampsamps=round(length(tempsig)/2);
                                set(ud.rampms,'String',num2str(round(1000*rampsamps/fs)));
                            end
                            t=0:rampsamps-1; c=pi/(rampsamps-1);
                            ham=0.5-0.5*cos(c*t);
                            %hwin=round(rampsamps/2);
                            hwin=rampsamps;
                            ramp=ones(1,length(tempsig));
                            ramp(1:hwin)=ham(1:hwin);
                            dursamps=length(tempsig);
                            ramp(dursamps-hwin+1:dursamps)=fliplr(ham(1:hwin));
                            tempsig=tempsig.*ramp;
                        end  
                        
                        adsig=[tempsig zeros(1,size(originalsig,2)-frompadding-topadding-length(adsig))];
                    end
   
                    if  reperiod > 0
                        for i=1:ceil((to-from)/reperiod)
                            tempsig=adsig(1,1:round(duration*ud.fs/1000));
                            
                            t=0:rampsamps-1; c=pi/(rampsamps-1);
                            ham=0.5-0.5*cos(c*t);
                            hwin=rampsamps;
                            ramp=ones(1,length(tempsig));
                            dursamps=length(tempsig);
                            ramp(dursamps-hwin+1:dursamps)=fliplr(ham(1:hwin));
                            tempsig=tempsig.*ramp;
                            
                            insert=[insert level*tempsig zeros(1,round((reperiod-duration)*ud.fs/1000)) ];
                        end
                        if inpadding < size(insert,2)
                            tempsig=insert(:,1:inpadding);
                                                        
                            t=0:rampsamps-1; c=pi/(rampsamps-1);
                            ham=0.5-0.5*cos(c*t);
                            hwin=rampsamps;
                            ramp=ones(1,length(tempsig));
                            dursamps=length(tempsig);
                            ramp(dursamps-hwin+1:dursamps)=fliplr(ham(1:hwin));
                            insert=tempsig.*ramp;
                            

                        end
                    else
                        
                        insert=level*adsig(1,1:size(originalsig,2)-frompadding-topadding);
                    end
                 
                    sig=[zeros(1,frompadding) insert zeros(1,size(originalsig,2)-size(insert,2)-frompadding)];
                    ud.addedsignals=[ud.addedsignals; sig];
                    ud.added=ud.added+1;
                    
                    SeeSigSpect(originalsig,ud.addedsignals,fs,ud);
                    ud.UndoList=[ud.UndoList; [0 zeros(1,ud.numchans)]]; 
                    set(gcf,'UserData',ud);  
                    drawnow     
                end
                
            case 'time reverse'
                if sum(ud.manipulated) > 0
                    ud.UndoList=[ud.UndoList; [1 ud.inverted]]; 
                    for i=1:length(ud.manipulated)
                        if ud.manipulated(i)==1
                            if ud.inverted(i)==1
                                ud.inverted(i)=0;
                            else
                                ud.inverted(i)=1;
                            end
                        end
                    end
                    
                    SeeSigSpect(originalsig,ud.addedsignals,fs,ud);
                end
                set(gcf,'UserData',ud);  
                
            case 'gain'
                if sum(ud.manipulated) > 0
                    
                    ud.UndoList=[ud.UndoList; [2 ud.gain]];
                    for i=1:length(ud.manipulated)
                        if ud.manipulated(i) == 1
                            ud.gain(i)=level;
                        end
                    end
                    SeeSigSpect(originalsig,ud.addedsignals,fs,ud);                
                    drawnow
                    
                end
                set(gcf,'UserData',ud);  
                
                
        end
        
        
        
        
    case 'display'
        ud=get(gcf,'UserData');
        set(ud.sigline,'XData',1:length(ud.sig),'YData',ud.sig);
        dft=fft(ud.sig); 
        dft=dft(2:round(length(dft)/2));
        set(ud.dftline,'XData',1:length(dft),'YData',20*log10(abs(dft)));
        set(gcf,'UserData',ud);
        
        
    case 'save'
        ud=get(gcf,'UserData');
        savedir=pwd;
        [f,p]=uiputfile(fullfile(savedir,'createdsound.wav','*.wav'),'SAVE sound as');
        cd(savedir);
        
        if f
            s=AssembleSignal(ud);
            % s=zeros(1,5000);
            wavwrite(s,ud.fs,[p f]);
        end
        
        
    case 'ClearAll'
        ud=get(gcf,'UserData');
        originalsig=ud.selected*ud.distorted;
        ud.added=0;
        ud.addedsignals=[];
        ud.inverted=zeros(size(ud.inverted));
        ud.sinewaved=zeros(size(ud.sinewaved));
        ud.nosignal=1;
        ud.gain=ones(1,sum(ud.selected));
        SeeSigSpect(originalsig,ud.addedsignals,ud.fs,ud);
        
        
        set(gcf,'UserData',ud);  
        set(findobj('Tag','clearButton'),'Enable','off');
        set(findobj('Tag','clearallButton'),'Enable','off');
        ud.UndoList=[]; 
        drawnow
        
    case 'cancel'
        %close

         if strcmp(questdlg('Are you sure you want to close?'),'Yes');
         
             delete(gcf);
         end
        
    case 'selectSignal'
        lud=get(gcbo,'UserData');
        ud=get(gcf,'UserData');
        chan=lud.chan;
        ud=get(gcf,'UserData');
        if strcmp(get(gcf,'SelectionType'),'extend')
            wavplay(ud.distorted(chan,:),ud.fs);
        else
            if ~ud.manipulated(chan)
                LowlightLine(ud.squares(chan)); 
                LowlightLine(ud.lines(chan));
                
                ud.manipulated(chan)=1;
            else
                HighlightLine(ud.squares(chan));
                
                HighlightLine(ud.lines(chan));
                ud.manipulated(chan)=0;  
            end
            set(gcf,'UserData',ud);
        end
        drawnow
        
    case 'SelectAll'
        ud=get(gcf,'UserData');
        for chan=1:length(ud.manipulated)
            if ud.manipulated(chan) ~= 1
                LowlightLine(ud.squares(chan)); 
                LowlightLine(ud.lines(chan));
                
                ud.manipulated(chan)=1;
            end
        end
        set(gcf,'UserData',ud);
        
    case 'UnSelectAll'
        ud=get(gcf,'UserData');
        for chan=1:length(ud.manipulated)
            if ud.manipulated(chan) ~= 0
                HighlightLine(ud.squares(chan)); 
                HighlightLine(ud.lines(chan));
                
                ud.manipulated(chan)=0;
            end
        end
        set(gcf,'UserData',ud);
        
        %     case 'drawspect'
        %         
        %         ud=get(gcf,'UserData');
        %         
        %         sg=spectrogram(ud.selected*ud.distorted,ud.fs,20,1);
        %         sg=sg';
        %         numchanssel=0;
        %         for c=1:ud.numchans
        %             if ud.selected(c)
        %                 numchanssel=numchanssel+1;
        %             end
        %         end
        %         %   if numchanssel==0
        %         %       sg(:,:)=-10;
        %         %   end
        %         axes(ud.spaxes);
        %         ud.im=imagesc(sg);
        %         [nc,nf]=size(sg);
        %         set(ud.spaxes,'XLim',[1 nf],'YLim',[1 nc]);
        %         
        %         set(ud.im,'CData',sg);
        %         
        %         set(ud.im,'ButtonDownFcn','','EraseMode','xor');
        %         drawnow
        %         
        %         set(gcf,'UserData',ud);
        %         
        
    otherwise
        orejauievent('createsignal_oreja',action);
        
end  

function x=localtone(freq,dursamps,level,fs)
x=level.*sin(2*pi*(freq/fs)*(1:dursamps));

function a=dB2amp(d)
a=power(10,d/20);

%-----
function y=delay(x,t)
lx=length(x)-t;
y=[zeros(1,t)  x(1:lx)];

%--------
function [env,carrier]=gammatoneEnvCarrier(x,fshz,cfhz)
% envelope and carrier form of complex gammatone

bwcorrection=1.019;
wcf=2*pi*cfhz;
tpt=(2*pi)/fshz;
bw=erb(cfhz)*bwcorrection;

a=exp(-bw*tpt);
kT=[0:length(x)-1]/fshz;
gain=((bw*tpt)^4)/6;                          % integral of imp resp

q=exp(-j*wcf*kT).*x;                          % shift down to d.c.
p=filter([1 0],[1 -4*a 6*a^2 -4*a^3 a^4],q);	% filter: part 1
u=filter([1 4*a 4*a^2 0],[1 0],p);            % filter: part 2
env=gain*abs(u);
carrier=cos(wcf*kT + angle(u));

%-----------
function e=sampleEnv(env,interval)
pts=round(length(env)/interval)-1;
e=max(abs(reshape(env(1:(interval*pts)),interval,pts)));

%------
% function l=CreateLine(p,len,parent)
% x=[1:len (len-1):-1:2];
% y=p*ones(size(x));
% pat=patch(x,y,[0.9 0.9 0.7]);
% set(pat,'Erasemode','xor');
% l=line(1:len,p*ones(1,len));
% set(l,'Color',[0.9 0.9 0.7],'Erasemode','xor','ButtonDownFcn',...
%     'createsignal_oreja selectSignal');
% % %set(l,'Color',[0.5 0.2 0.7],'Erasemode','xor');
% 
% lud.patch=pat;
% lud.chan=p;

function ChangeLine(l,c,env)
lud=get(l,'UserData');
lenv=length(env);
set(lud.patch,'YData',[c+3*env c-3*fliplr(env(2:lenv-1))]);

function HighlightLine(l)
lud=get(l,'UserData');
set(lud.patch,'FaceColor',[0.9 0.9 0.7]);
set(l,'Color',[0.9 0.9 0.7]);
set(l,'MarkerFaceColor',[0.9 0.9 0.7]);
set(l,'MarkerEdgeColor',[0.9 0.9 0.7]);


function LowlightLine(l)
set(l,'Color',[0.5 0.6 0.3]);
lud=get(l,'UserData');
set(lud.patch,'FaceColor',[0.5 0.6 0.3]);
set(l,'MarkerFaceColor',[0.5 0.6 0.3]);
set(l,'MarkerEdgeColor',[0.5 0.6 0.3]);

function signal=AssembleSignal(ud)

distorted2=[];
j=0;
for i=1:length(ud.selected)
    if ud.selected(i) == 1
        j=j+1;
        if ud.inverted(j)==1
            d=ud.distorted(i,:);
            if ud.sinewaved(j) == 1
                r=ud.fs;
                [F,M] = swsmodel(d',r);
                d = synthtrax(F,M,r);
                
                d = [zeros(1,size(ud.distorted,2)-length(d)) d];
            end
            
            distorted2=[distorted2; ud.gain(j).*fliplr(d)];
        else
            d=ud.distorted(i,:);
            if ud.sinewaved(j) == 1
                r=ud.fs;
                [F,M] = swsmodel(d',r);
                d = synthtrax(F,M,r);
                
                d = [zeros(1,size(ud.distorted,2)-length(d)) d];
                
                
            end  
            
            distorted2=[distorted2; ud.gain(j).*d];
        end
        
    end
    
end

signal=ones(1,j)*distorted2;

for i=1:ud.added
    signal=signal+ud.addedsignals(i,:);
end

function drawspect(ud)

signal=AssembleSignal(ud);
sg=spectrogram(signal+eps,ud.fs,20,1); %the value 20 is the window size
% si aumenta la resolucion es mayor pero se pierde precision
sg=sg';

axes(ud.spaxes);
ud.im=imagesc(sg);
        ca = caxis;
        dBrange = 80;
        caxis([ca(2)-dBrange ca(2)]);

set(ud.im,'CData',sg);
set(ud.im,'ButtonDownFcn','','EraseMode','xor');
[nc,nf]=size(sg);
set(ud.spaxes,'XLim',[1 nf],'YLim',[1 nc]);
set(gcf,'UserData',ud); 


function SeeSigSpect(originalsignal,addedsignals,fs,ud)

%                r=ud.fs;
%                 [F,M] = swsmodel(d',r);
%                 d = synthtrax(F,M,r);
%             end

%                 
%                 wavwrite(d,r,'dpwe_src.wav');
%                 wavwrite(dr,r,'dpwe_out.wav');
% 
%                 soundsc(dr,r)

signal=AssembleSignal(ud);

sg=spectrogram(signal+eps,fs,20,1);
sg=sg';

axes(ud.spaxes);
set(ud.im,'CData',sg);


set(ud.im,'ButtonDownFcn','','EraseMode','xor');
[nc,nf]=size(sg);
set(ud.spaxes,'XLim',[1 nf],'YLim',[1 nc]);



set(gcf,'UserData',ud); 

refresh;


function l=CreateSquare(c,p,len,parent)
axes(parent);
x=[1:len (len-1):-1:2];
y=p*ones(size(x));
pat=patch(x,y,[0.9 0.9 0.7]);
set(pat,'Erasemode','xor');

l=line(2:2,p*ones(1,1),'MarkerEdgeColor',[0.9 0.9 0.7],'MarkerFaceColor',[0.9 0.9 0.7],'Marker','o','MarkerSize',10);
set(l,'Erasemode','xor','ButtonDownFcn',...
    'createsignal_oreja selectSignal');

lud.patch=pat;
lud.chan=p;
set(l,'UserData',lud);

%=============SINEWAVES==================================



%---------COSAS QUE SOBRAN---------


%function oud=StartSelection(ud)
%pos=get(gca,'CurrentPoint');
%sg=spectrogram(ud.selected*ud.distorted,ud.fs,20,1);
%sg=sg';
%[nc,nf]=size(sg);
%ud.im=imagesc(sg);
%ud.line1=line('XData',[pos(1) pos(1)],'YData',[0 nc],'ZData',[1 -1],'LineWidth',3,'Color',[0.5 0.2 0.7]);
%set(ud.im,'ButtonDownFcn','oreja speech_window_click');
%oud=ud;
%drawnow;

%case 'harmonics'
% fundamental=getuicontrolvalue(ud.fundamental,'num');
% number=getuicontrolvalue(ud.number,'num');
% level=dB2amp(getuicontrolvalue(ud.harmonicslevel,'num'));
% sig=zeros(1,dursamps);
%for i=1:number
%  sig=sig+localtone(i*fundamental,dursamps,level,fs);
%end  

%case 'resonance'
%freq=getuicontrolvalue(ud.resfreq,'num');
%bw=getuicontrolvalue(ud.resbw,'num');
%level=dB2amp(getuicontrolvalue(ud.resonancelevel,'num'));
%% work out z plane locations of things
%r=exp(-pi*bw/fs);
%f=2*pi*freq/fs;
% convert to transfer function form
%rc=r*cos(f);
%rs=r*sin(f);
%[num,den]=zp2tf([],[rc+j*rs; rc-j*rs],1);
%sig=zeros(1,dursamps);
%sig(1)=level;
%sig=filter(num,den,sig);

%otherwise
%  disp(['unknown option ' get(ud.lastradio,'String')])


%sub_chan_vect=find(channel_vect==0);
%for c=sub_chan_vect
%    [env,carrier]=gammatoneEnvCarrier(ud.sig,ud.fs,ud.cfs(c));
%    [nenv,ncarrier]=gammatoneEnvCarrier(noise,ud.fs,ud.cfs(c));
%    ud.envs(c,:) = env;
%    ud.cars(c,:) = carrier;
%    ud.noisecars(c,:) = ncarrier;
%    ud.distorted(c,:) = env.*carrier;
%    e=sampleEnv(ud.distorted(c,:),ud.sampsPer10ms);
%    ChangeLine(ud.lines(c),c,e); 
%    set(ud.wavstatus,'String',['Computing Hilbert envelope for chan ' num2str(c)]); 
%    
%    drawnow
%end
