function fig=createsignaloreja_gui
% createsignal_gui
%
% user interface for signal creation
%

fig=createorejafig('createsignal_oreja'); 

set(fig,'CloseRequestFcn','createsignal_oreja cancel');


figcol=get(fig,'Color');
bc=figcol;
wc=[1.0 1.0 1.0];

fontsize = 10;
pwidth=0.135;
pheight=0.04; eheight=0.05;
yinc=0.07;
colsep=-0.00;
namewidth=0.13; boxwidth=0.11; unitswidth=0.04;
cols=[0.01 0.2 0.33 0.41 0.45 0.5 0.65 0.71 0.75 0.8];

ypos=0.8;
bheight=0.08;

% % Text appearing on top 
% ud.textop=uicontrol('Parent',fig,...
% 'Position',[0.1 0.9 0.4 0.04],...
% 'String','Click to select',...
% 'FontSize',fontsize,...
% 'Style','text')

%First axes
ud.YLim = 1.1*[-1 1];
ud.dftaxes = axes('Parent',fig,...
    'Position',[0.08 0.55 0.55 0.35],...  
    'DrawMode','fast',...
    'NextPlot','replacechildren',...
    'Box','on','Tag','dftWin','YTick',[]);
xlabel('Channels selected')
ylabel('Frequencies')

%Second axes     
ud.spaxes = axes('Parent',fig,...
    'Position',[0.08 0.1 0.55 0.35],...
    'DrawMode','fast',...
    'NextPlot','replacechildren',...
    'Box','on','Tag','spWin','YTick',[]);
xlabel('Channels mixed')
ylabel('Frequencies')

% Bar for the seleccion of channels
ud.chanAxes = axes('Parent',fig,...
'Position',[0.63 0.55 0.02 0.35],...
'DrawMode','fast',...
'NextPlot','replacechildren',...
'Box','on',...
'Color', [1 0.9 0.9],...
'XTick',[],...
'YTick',[]);
      
%frame_1
uicontrol('Parent',fig, 'Position',[0.69 0.18 0.28 0.78],...
    'BackGroundColor',[1 1 0.8],'Style','frame');
%frame_2
uicontrol('Parent',fig, 'Position',[0.7 0.59 0.26 0.36],...
    'BackGroundColor',[1 1 0.8],'Style','frame');
%frame_3
uicontrol('Parent',fig, 'Position',[0.7 0.2 0.26 0.38],...
    'BackGroundColor',[1 1 0.8],'Style','frame');
%frame_4
uicontrol('Parent',fig, 'Position',[0.71 0.745 0.24 0.001],...
    'BackGroundColor',[1 1 0.8], 'Style','frame');

%buttons
uicontrol('Parent',fig, 'BackgroundColor',[.8 0.8 0.5],...
	'Position',[0.72 0.04  0.08 0.05], 'Callback','createsignal_oreja add',...
	'String','add/apply', 'FontSize',fontsize,'Style','pushbutton','Tag','addButton','Enable','off');
uicontrol('Parent',fig,'BackgroundColor',[.8 0.8 0.5],...
	'Position',[0.82 0.04  0.08 0.05], 'Callback','createsignal_oreja save',...
	'String','save', 'FontSize',fontsize,'Style','pushbutton','Tag','saveButton','Enable','off');
uicontrol('Parent',fig, 'BackgroundColor',[.8 0.8 0.5],...
	'Position',[0.68 0.1  0.08 0.05], 'Callback','createsignal_oreja clear',...
	'String','undo', 'FontSize',fontsize, 'Style','pushbutton','Tag','clearButton','Enable','off');
uicontrol('Parent',fig,'BackgroundColor',[.8 0.8 0.5],...
	'Position',[0.77 0.1  0.08 0.05], 'Callback','createsignal_oreja ClearAll',...
	'String','undo all', 'FontSize',fontsize, 'Style','pushbutton','Tag','clearallButton','Enable','off');
uicontrol('Parent',fig,'BackgroundColor',[.8 0.8 0.5],...
	'Position',[0.87 0.1  0.08 0.05], 'Callback','createsignal_oreja cancel',...
	'String','close', 'FontSize',fontsize,'Style','pushbutton','Tag','cancelButton','Enable','on');

%+++++++++++++++++ PLAY
uicontrol('Parent',fig,'BackgroundColor',[0.8 0.8 0.5],...
	'Position',[0.03 0.45  0.05 0.03], 'Callback','createsignal_oreja playMix;',...
	'String','play', 'FontSize',fontsize,'Style','pushbutton','Tag','playButton','Enable','off');
uicontrol('Parent',fig,'BackgroundColor',[0.8 0.8 0.5],...
    'Position',[0.03 0.9  0.05 0.03], 'Callback','createsignal_oreja playOriginal;',...
	'String','play', 'FontSize',fontsize,'Style','pushbutton','Tag','playButton','Enable','off');

%+++++++++++++++++ SELECT
uicontrol('Parent',fig,'BackgroundColor',[0.8 0.8 0.5],...
    'FontSize',fontsize-1,'Callback','createsignal_oreja SelectAll','Position',[0.58 0.95  0.07 0.03], ...
    'Tag','SelectAll','String','select all', 'Enable','on','Style','pushbutton'),...
    
uicontrol('Parent',fig,  'BackgroundColor',[0.8 0.8 0.5],...
    'FontSize',fontsize-0.9,'Callback','createsignal_oreja UnSelectAll', 'Position',[0.58 0.91  0.07 0.03], ...
    'Tag','UnSelectAll','String','unselect all','Enable','on','Style','pushbutton'),...
    
%+++++++++++++++++ TIME & FREQUENCY
uicontrol('Parent',fig,'Style','text','String','Time:','FontSize',0.05,...
  'Position',[0.4 0.95 0.05 0.03],'HorizontalAlignment','right');
ud.timebox=uicontrol('Parent',fig,'Style','text','String','0','FontSize',0.05,...
  'Position',[0.45 0.95 0.05 0.03]);
uicontrol('Parent',fig,'Style','text','FontAngle','italic','String','ms','FontSize',0.05,...
  'Position',[0.5 0.95 0.05 0.03],'HorizontalAlignment','left');
  
uicontrol('Parent',fig,'Style','text','String','Freq:','FontSize',0.05,...
  'Position',[0.4 0.91 0.05 0.03],'HorizontalAlignment','right');
ud.freqbox=uicontrol('Parent',fig,'Style','text','String','0','FontSize',0.05,...
  'Position',[0.45 0.91 0.05 0.03]);
uicontrol('Parent',fig,'Style','text','FontAngle','italic','String','Hz','FontSize',0.05,...
  'Position',[0.5 0.91 0.05 0.03],'HorizontalAlignment','left');
   

%---- signal type radios 
xpos=0.71;
ypos=0.8;

%%DISTORTIONS
uicontrol('Parent',fig, ...
  'Position',[xpos 0.9 pwidth+0.1 pheight],...
  'String','distortions','FontSize',13,'Style','text','HorizontalAlignment','center',...
  'BackgroundColor',[.8 0.8 0.5]);
% TONE
uicontrol('Parent',fig, ...
  'Position',[xpos 0.8 pwidth pheight],...
  'Callback','createsignal_oreja handleradio',...
  'String','tone','FontSize',fontsize,'Style','radio','HorizontalAlignment','left',...
  'Tag','sigradio','BackgroundColor',[1 0.8 0.7],'Enable','off');

% TIME REVERSE
uicontrol('Parent',fig, ...
  'Position',[xpos 0.65 pwidth pheight],...
  'Callback','createsignal_oreja handleradio',...
  'String','time reverse','FontSize',fontsize,'Style','radio','HorizontalAlignment','left',...
  'Tag','sigradio','BackgroundColor',[1 0.7 0.8],'Enable','off');

% SPEECH
uicontrol('Parent',fig, ...
  'Position',[xpos 0.85 pwidth pheight],...
  'Callback','createsignal_oreja handleradio',...
  'String','speech','FontSize',fontsize,'Style','radio','HorizontalAlignment','left',...
  'Tag','sigradio','BackgroundColor',[1 0.8 0.7],'Enable','off');

% NOISE
uicontrol('Parent',fig, ...
  'Position',[xpos 0.75 pwidth pheight],...
  'Callback','createsignal_oreja handleradio',...
  'String','noises','FontSize',fontsize,'Style','radio','HorizontalAlignment','left',...
  'Tag','sigradio','BackgroundColor',[1 0.8 0.7],'Enable','off');

% GAIN
uicontrol('Parent',fig, ...
  'Position',[xpos 0.7 pwidth pheight],...
  'Callback','createsignal_oreja handleradio',...
  'String','gain','FontSize',fontsize,'Style','radio','HorizontalAlignment','left',...
  'Tag','sigradio','BackgroundColor',[1 0.7 0.8],'Enable','off');

% SINEWAVES REPLICAS
uicontrol('Parent',fig, ...
  'Position',[xpos 0.6 0.2 pheight],...
  'Callback','createsignal_oreja handleradio',...
  'String','sinewaves replicas','FontSize',fontsize,'Style','radio','HorizontalAlignment','left',...
  'Tag','sigradio','BackgroundColor',[1 0.7 0.8],'Enable','off');


% GENERAL SETTINGS ==================================================
uicontrol('Parent',fig, ...
  'Position',[xpos 0.53 pwidth+0.1 pheight],...
  'String','global settings','FontSize',13,'Style','text','HorizontalAlignment','center',...
  'BackgroundColor',[.8 0.8 0.5]);

% FREQUENCY (text)
uicontrol('Parent',fig, ...
  'Position',[xpos 0.47 0.1 pheight],...
  'String','frequency: ', ...
  'FontSize',fontsize,...
  'HorizontalAlignment','right', 'Style','text');

% FREQUENCY (edit)
ud.freq=uicontrol('Parent',fig, ...
  'Position',[0.82 0.47 0.06 pheight],...
  'FontSize',fontsize,...
  'String','0', 'Enable', 'off',...
  'Tag','boxfrequency',...
  'HorizontalAlignment','right', 'Style','edit');

% FREQUENCY (text)
uicontrol('Parent',fig, ...
  'Position',[0.88 0.47 0.03 pheight],...
  'String','Hz','BackgroundColor',[1 1 0.8], ...
  'FontSize',fontsize,...
  'HorizontalAlignment','center', 'Style','text');

% dB (text)
uicontrol('Parent',fig, ...
  'Position',[xpos 0.42 0.1 pheight],...
  'String','dB: ',...
  'FontSize',fontsize,...
  'HorizontalAlignment','right', 'Style','text');

% dB (edit)
ud.freqlevel=uicontrol('Parent',fig, ...
  'Position',[0.82 0.42 0.06 pheight],...
  'String', '0',...
  'Enable', 'off',...
  'Tag','lButton',...
  'FontSize',fontsize,...
  'HorizontalAlignment','right', 'Style','edit');


% MANIPULATION TIME (text)
uicontrol('Parent',fig, ...
  'Position',[0.71 0.32 0.04 pheight],...
  'String','from: ', ...
  'FontSize',fontsize,...
  'HorizontalAlignment','right', 'Style','text');

% MANIPULATION TIME (text)
uicontrol('Parent',fig, ...
  'Position',[0.82 0.32 0.03 pheight],...
  'String','to: ', ...
  'FontSize',fontsize,...
  'HorizontalAlignment','right', 'Style','text');

% MANIPULATION TIME (edit)
ud.from=uicontrol('Parent',fig, ...
  'Position',[0.755 0.32 0.06 pheight],...
  'Enable', 'on',...
  'String', '0','FontSize',fontsize,...
  'CallBack','createsignal_oreja changefrom',...
  'HorizontalAlignment','right', 'Style','edit');

% MANIPULATION TIME (edit)
ud.to=uicontrol('Parent',fig, ...
  'Position',[0.86 0.32 0.06 pheight],...
  'String', '0','Enable', 'on',...
  'FontSize',fontsize,...
  'Tag','toButton',...
  'CallBack','createsignal_oreja changeto',...
  'HorizontalAlignment','right', 'Style','edit');

% MANIPULATION TIME (text)
uicontrol('Parent',fig, ...
  'Position',[0.92 0.32 0.03 pheight],...
  'String','ms','FontSize',fontsize,'BackgroundColor',[1 1 0.8], ...
  'HorizontalAlignment','center', 'Style','text');


% RAMP (text)
uicontrol('Parent',fig, ...
  'Position',[xpos 0.37 0.1 pheight],...
  'String','ramp: ', ...
  'FontSize',fontsize,...
  'HorizontalAlignment','right', 'Style','text');

% RAMP (edit)
ud.rampms=uicontrol('Parent',fig, ...
  'Position',[0.82 0.37 0.06 pheight],...
  'String', '0','Enable', 'off',...
  'FontSize',fontsize,...
  'HorizontalAlignment','right', 'Style','edit');

% RAMP (text)
uicontrol('Parent',fig, ...
  'Position',[0.88 0.37 0.03 pheight],...
  'String','ms','FontSize',fontsize,'BackgroundColor',[1 1 0.8], ...
  'HorizontalAlignment','center', 'Style','text');


xpos=xpos+namewidth;

% DURATION
uicontrol('Parent',fig, ...
  'Position',[0.71 0.22 0.1 pheight],...
  'String','duration: ', ...
  'FontSize',fontsize,...
  'HorizontalAlignment','right', 'Style','text');

ud.dur=uicontrol('Parent',fig, ...
  'Position',[0.82 0.22 0.06 pheight],...
  'String', '0',...
  'Enable', 'off',...
  'FontSize',fontsize,...
  'HorizontalAlignment','right', 'Style','edit');

uicontrol('Parent',fig, ...
  'Position',[0.88 0.22 0.03 pheight],...
  'String','ms',...
  'FontSize',fontsize,...
  'BackgroundColor',[1 1 0.8], ...
  'HorizontalAlignment','center', 'Style','text');

% REP. PERIOD
uicontrol('Parent',fig, ...
  'Position',[0.71 0.27 0.1 pheight],...
  'String','rep. period: ', ...
  'FontSize',fontsize,...
  'HorizontalAlignment','right', 'Style','text');

ud.reperiod=uicontrol('Parent',fig, ...
  'Position',[0.82 0.27 0.06 pheight],...
  'String', '0',...
  'Enable', 'off',...
  'FontSize',fontsize,...
  'HorizontalAlignment','right', 'Style','edit');

uicontrol('Parent',fig, ...
  'Position',[0.88 0.27 0.03 pheight],...
  'String','ms','FontSize',fontsize,'BackgroundColor',[1 1 0.8], ...
  'HorizontalAlignment','center', 'Style','text');




% TYPE OF NOISE
ud.noisetype=uicontrol('Parent',fig, ...
  'Position',[0.85 0.75 0.1 pheight],...
  'String','chirp up|chirp down|white|pink|brown', ...
  'FontSize',fontsize,...
  'Style','popupmenu','BackgroundColor',[1 1 0.8], ...
  'Tag','freqsepPopup', ...
  'HorizontalAlignment','center',...
  'Value',1); 

% % TYPE OF SPEECH
% ud.speechtype=uicontrol('Parent',fig, ...
%   'Position',[0.85 0.75 0.1 pheight],...
%   'String','speech-like|female|male|child', ...
%   'FontSize',fontsize,...
%   'Style','popupmenu','BackgroundColor',[1 1 0.8], ...
%   'Tag','freqsepPopup', ...
%   'HorizontalAlignment','center',...
%   'Value',1);


set(gcf,'UserData',ud);
set(fig,'UserData',ud);