function [name,sig,fs,fullpathname,dirname]=loadsig2(sigdir,dontask,fullname)
%LOADSIG load signal in one of known formats
%
% USAGE:
%   [name,sig,fs]=loadsig(sigdir)
%
% where:
%   sigdir is the starting directory for the UI
%   fs is the sampling frequency
%
% Can load .wav, .au or .snd formats at present

% renamed from loadSignal for V2.1 release
% SJW/MPC 11/6/99

name=[];
sig=[];
fs=0;
savedir=pwd; %returns the current directory to savedir
opendir=sigdir;
cd(opendir);
if ~strcmp(fullname,'')
    fullpathname = strcat('',fullname,'');
end

if ~dontask
    fullpathname='';
    if strcmp(computer,'PCWIN')
        [filename,dirname] = uigetfile(fullfile(sigdir,'*.*'),'New Signal');
    else
        [filename,dirname] = uigetfile(fullfile(sigdir,'*'),'New Signal');
    end
    if filename
        fullpathname = strcat(dirname,filename);
    end
end

cd(savedir)
if fullpathname
    [dirname,filename,ext,ver] = fileparts(fullpathname);
    name=filename;
    if strcmp(ext,'.wav')
        [sig,fs]=wavread(fullpathname);
    elseif strcmp(ext,'.au')
            [sig,fs]=auread(fullpathname);    
    elseif strcmp(ext,'.snd')
        [sig,fs]=auread(fullpathname);
    elseif strcmp(ext,'.f32')
        fid=fopen(fullpathname,'r');
        sig=fread(fid,'float');
        % de momento hay que cambiar la fs y adaptarla al fichero que te bajas
        fs=25000;
        % sig=downsample(interp(sig,25),25);
        fclose(fid);
    else
        msgbox('loadsig: Signal file format is not one of .wav, .au, or .snd');
        name=[];
    end
    if size(sig,2)>10
        warndlg(['loadsig: Unable to load signal ' name]);
    else
        sig=sig(:);
    end  
end
