function [s] = chirp_down (fs, samples) %f0>f1
%t= 0:1/8000:1; %1 sec @4kHz sample rate
f0=2000;
f1=1000;
%y = fliplr(chirp(t, f1, 1, f0,'q')); %'q' is quadratic, 'li' is linear

% dur = 0.060;
% fs = 8000;
% 
% samples = round(dur*fs);

% linear sweep on log-frequency axis
ifrq = exp(log(f0)+(log(f1)-log(f0))*(1:samples)/samples);
% generate sinusoid matching instantaneous frequencies ifrq
y = cos(cumsum(2*pi*ifrq/fs));

% Apply raised-cosine ramps at onset/offset
tramp = 0.010;
tsamp = 1/fs;
wramp = 0.5*(1-cos([0:tsamp:tramp]/tramp*pi));

win = [wramp, ones(1, length(y)-2*length(wramp)), fliplr(wramp)];

s = win.*y;
