fig=createorejafig('oreja'); 
fig=createorejaloadmenu(fig);
ud.noplay=1;

filemenu = uimenu('Parent',fig,'Label','Transcription');
   ud.loadopt=uimenu('Parent',filemenu,...
       'Callback','oreja loadannot', 'Label','load transcription');
   ud.saveopt=uimenu('Parent',filemenu, ...
       'Callback','oreja saveannot', 'Label','save transcription');
   ud.saveAsopt=uimenu('Parent',filemenu, ...
       'Callback','oreja saveAsannot', 'Label','save transcription as');
  
set([ud.saveAsopt ud.saveopt ud.loadopt],'Enable','off');...

fig = createorejamenus(fig);

% major row & column positions

left=0.06;
top=0.9;
bottom=0.05;
mid=0.5;
right=0.75;


%check box to change the filter
uicontrol('Parent',fig,'Style','text','String',' 1 ERB:','FontSize',0.05,...
  'Position',[right+0.1 0.7 0.05 0.03],'HorizontalAlignment','right');
ud.boxfilter = uicontrol('Parent',fig,'Style','checkbox', 'Value', 0,...
  'Position',[right+0.18 0.7 0.02 0.03],...
  'Callback','oreja ERB');


% fontsize and type

fontsize = 10;

%Channel's window
ud.wavAxes = axes('Parent',fig,...
'Position',[left 0.14 0.75 0.5],...
'DrawMode','fast',...
'NextPlot','add',...
'Color', [1 0.8 0.9],...
'XTick',[],...
'Tag','WavWin',...
'Box','on'); 


% Text that appear underneath the speech window
ud.wavstatus = uicontrol('Parent',fig,...
'Position',[left bottom+0.59 right-left 0.04],...
'String','',...
'FontSize',fontsize,...
'Style','text');

% Speech's window
ud.YLim = 1.1*[-1 1];
ud.spectAxes = axes('Parent',fig,...
'Position',[left bottom+0.68 0.75 0.22],...
'DrawMode','fast',...
'NextPlot','replacechildren',...
'Color', [1 0.9 0.9],...
'Tag', 'SpeechWin',...
'Box','on',...
'XTick',[],...
'YTick',[]);

% Bar for the signal
ud.signalAxes = axes('Parent',fig, ...
    'Box','on', ...
    'ButtonDownFcn','oreja play', ...
    'DrawMode','fast', ...
    'FontSize',9, ...
    'NextPlot','replacechildren', ...
    'Position',[left bottom 0.75 0.04], ...
    'XLimMode','manual', ...
    'Tag', 'SignalWin', ...
    'XTick',[], ...
    'YTick',[], ...
    'YLim',ud.YLim, ...
    'YLimMode','manual');

%  SIGNAL's LINE 
ud.signalLine = line('Parent',ud.signalAxes, ...
    'ButtonDownFcn','oreja play', ...
    'Color',[0.7 0.2 1],...
    'XData',[0 0],'YData',[0 0]);

% Bar for the annotations
ud.annotAxes = axes('Parent',fig, ...
    'Box','on', ...
    'Color',[1 1 1], ...
    'DrawMode','fast', ...
    'FontSize',9, ...
    'NextPlot','replacechildren', ...
    'Tag', 'AnnotWin',...
    'Position',[left bottom+0.04 0.75 0.04], ...
    'XLimMode','manual', ...
    'XTick',[], ...
    'YTick',[],...
    'XTickMode','manual', ...
    'YLimMode','manual', ...
    'YLim',ud.YLim);




% LINES
ud.signalLC = line('Parent',ud.signalAxes,'ButtonDownFcn','oreja left',...
   'EraseMode','xor','XData',[0 0],'YData',ud.YLim,'Color','black');
ud.signalRC = line('Parent',ud.signalAxes,'ButtonDownFcn','oreja derecha',...
   'EraseMode','xor','XData',[0 0],'YData',ud.YLim,'Color','black');
ud.annotLC = line('Parent',ud.annotAxes,'Color','black',...
   'EraseMode','xor','XData',[0 0],'YData',ud.YLim,'ButtonDownFcn','oreja left');
ud.annotRC = line('Parent',ud.annotAxes,'Color','black',...
   'EraseMode','xor','XData',[0 0],'YData',ud.YLim,'ButtonDownFcn','oreja derecha');
ud.spectLC = line('Parent',ud.spectAxes,'ButtonDownFcn','oreja left',...
   'EraseMode','xor','XData',[0 0],'YData',ud.YLim,'Color','black');
ud.spectRC = line('Parent',ud.spectAxes,'ButtonDownFcn','oreja derecha',...
   'EraseMode','xor','XData',[0 0],'YData',ud.YLim,'Color','black');
ud.wavLC = line('Parent',ud.wavAxes,'ButtonDownFcn','oreja left',...
   'EraseMode','xor','XData',[0 0],'YData',ud.YLim,'Color','black');
ud.wavRC = line('Parent',ud.wavAxes,'ButtonDownFcn','oreja derecha',...
   'EraseMode','xor','XData',[0 0],'YData',ud.YLim,'Color','black');





%TIME & FREQUENCY
uicontrol('Parent',fig,'Style','text','String','Time:','FontSize',0.05,...
  'Position',[right+0.07 0.8 0.05 0.03],'HorizontalAlignment','right');
ud.timebox=uicontrol('Parent',fig,'Style','text','String','0','FontSize',0.05,...
  'Position',[right+0.12 0.8 0.05 0.03]);
uicontrol('Parent',fig,'Style','text','FontAngle','italic','String','ms','FontSize',0.05,...
  'Position',[right+0.16 0.8 0.05 0.03],'HorizontalAlignment','left');
  
uicontrol('Parent',fig,'Style','text','String','Freq:','FontSize',0.05,...
  'Position',[right+0.07 0.76 0.05 0.03],'HorizontalAlignment','right');
ud.freqbox=uicontrol('Parent',fig,'Style','text','String','0','FontSize',0.05,...
  'Position',[right+0.12 0.76 0.05 0.03]);
uicontrol('Parent',fig,'Style','text','FontAngle','italic','String','Hz','FontSize',0.05,...
  'Position',[right+0.16 0.76 0.05 0.03],'HorizontalAlignment','left');

%Segment ID
uicontrol('Parent',fig,'Style','text','String','Segment ID:','FontSize',0.05,...
  'Position',[right+0.07 0.1 0.08 0.03],'HorizontalAlignment','right');
ud.IDbox=uicontrol('Parent',fig,'Style','edit','String','?','FontSize',0.05,...
  'Position',[0.91 0.1 0.07 0.04],...
  'Callback','oreja segmentID');

% Bar for the seleccion of channels
ud.chanAxes = axes('Parent',fig,...
'Position',[0.81 bottom+0.09 0.03 0.5],...
'DrawMode','fast',...
'NextPlot','replacechildren',...
'Box','on',...
'Color', [1 0.9 0.9],...
'XTick',[],...
'YTick',[]);



%title that disappears when the signal is loaded
ud.spectstatus=uicontrol('Parent',fig,...
'Position',[left 0.95 0.68 0.03],...
'String','OREJA... for the design of psychoacoustic experiments',...
'FontSize',fontsize,...
'Style','text');

% Slider bar 
ud.sliderbar=uicontrol('Parent',fig,...
'Position',[left bottom+0.66 0.75 0.02],...
'Callback', 'oreja moveon',...
'Style','slider','Tag','SliderOne','Value',0.1, ...
'SliderStep',[0.01 0.1], ...
'Visible','off', ...
'Min',0,'Max',757);
% cy=top-0.1;
% right=right+0.02;


%Selection of num channels
uicontrol('Parent',fig, ...
'Position',[right 0.65 0.15 0.03], ...
'String','Number of channels:', ...
'FontSize',fontsize,...
'Style','text');

ud.chansmenu=uicontrol('Parent',fig, ...
'Callback','oreja changeNumchans', ...
'Position',[0.92 0.65 0.03 0.04], ...
'String','','HorizontalAlignment','center', ......
'FontSize',fontsize,...
'Style','edit');

%ZOOM IN
uicontrol('Parent',fig, ...
'Position',[right+0.07 0.9 0.08 0.05], ...
'String','zoom in', ...
'FontSize',fontsize,...
'Tag','ZoomIn',...
'Style','pushbutton', 'Enable', 'off');


%ZOOM OUT
uicontrol('Parent',fig, ...
'Position',[right+0.16 0.9 0.08 0.05], ...
'Tag','ZoomOut', ...
'String','zoom out', ...
'FontSize',fontsize,...
'Enable','Off',...
'Style','pushbutton');

%PLAY ORIGINAL
uicontrol('Parent',fig, ...
'Position',[right+0.07 0.84 0.08 0.05], ...
'Tag','PlayOriginal',...
'String','play original', ...
'FontSize',fontsize-0.7,...
'Callback','PlayOriginal', ...
'Style','pushbutton', 'Enable', 'off');

%PLAY SELECT
uicontrol('Parent',fig, ...
'Callback','PlaySelect',...
'FontSize',fontsize,...
'Position',[right+0.16 0.84 0.08 0.05], ...
'String','play select', ...
'Tag','PlaySelect',...
'Style','pushbutton', 'Enable', 'off');

%SELECT ALL
uicontrol('Parent',fig, ...
'FontSize',fontsize,...
'Callback','SelectAll', ...
'Position',[right+0.13 0.58 0.08 0.05], ...
'Tag','SelectAll',...
'String','select all', ...
'Enable','off',...
'Style','pushbutton');

%UNSELECT ALL
uicontrol('Parent',fig, ...
'FontSize',fontsize-0.9,...
'Callback','UnSelectAll', ...
'Position',[right+0.13 0.51 0.08 0.05], ...
'Tag','UnSelectAll',...
'String','unselect all', ...
'Enable','off', ...
'Style','pushbutton');


set(gcf,'UserData',ud);
set(fig,'UserData',ud);

